--myfont = Font.load("/default.ttf");
--Font.setPixelSizes(myfont,18)
skipDelay = 1;
soundEnabled = 0

CPU  = 2;
GPU  = 1;
NULL = 0
globalRenderType = CPU;

white   = Color.new(255,255,255);
black   = Color.new(0,0,0);
gray    = Color.new(82,82,82);
red     = Color.new(157,62,62);
green   = Color.new(62,157,62);
blue    = Color.new(62,62,157);

vndsPath        = "/vnds/";
gameName        = "Fate";
vndsSystemPath  = vndsPath .. "SYSTEM/"
vndsSavePath    = vndsPath .. "SAVES/"
gamePath        = vndsPath .. "NOVELS/" .. gameName;


TS = {  w = 400,
        h = 240};
BS = {  w = 320,
        h = 240};
Scr = { w = 800,
        h = 600};

textBoxArray ={
    wlimit = 35, --width limit of text
    "","","","","","","","","","","","","","","",""
};

function evaluateIf(LHS, OP, RHS)
    if (OP == "==") then
        return (LHS == RHS)
    elseif (OP == "!=") then
        return (LHS ~= RHS)
    elseif (OP == ">" ) then
        return (LHS > RHS)
    elseif (OP == "<" ) then
        return (LHS < RHS)
    elseif (OP == ">=" ) then
        return (LHS >= RHS)
    elseif (OP == "<=" ) then
        return (LHS <= RHS)
    end
end;

function writeFileWithVar(filename, var)
    local fileStream = io.open(filename,FCREATE)
    io.write(fileStream,0,var,#var)
    io.close(fileStream)
end;

function fileToTable(file, outTable)
    local i = 1;
    for line in io.lines(file) do
        outTable[i] = line;
        i = i + 1;
    end
end;

oldpad = Controls.read();

function makeWordList (input)   --split input string into a table of a bunch of separate words
    local i = 1;
    local wordlist = {};
    for word in input:gmatch("%S+") do
        wordlist[i] = word;
        i = i+1;
     end
     return wordlist;
end;

function shiftTableDown(inputTable, num)
    for i = 1, num, 1 do
        table.remove(inputTable, #inputTable);
        table.insert(inputTable,1,"");
    end
end;

function shiftTableUp(inputTable, num)
    for i = 1, num, 1 do
        table.remove(inputTable, 1);
        table.insert(inputTable,#inputTable+1,"");
    end
end;

function writeTextBoxArray (inputarr, strwrite)       -- takes a string containing "\n" newlines and splites and writes it into the linearray.
    local formatted = textWrap(strwrite, inputarr.wlimit,"", "  ");

    sto = 0;    --count the number of lines that will be written to the linearray.  Tells how far to shift the linearray to accomadate new text.
    for line in formatted:gmatch("[^\r\n]+") do
        sto = sto+1;
    end
    shiftTableUp(inputarr,sto);

    k = 1;
    for line in formatted:gmatch("[^\r\n]+") do
        inputarr[k+#inputarr-sto] = line;
        k = k+1;
    end
end;

function printTextBoxArray (inputarr, scr)      --writes the linearray on screen
    local Q = math.floor(TS.h/#inputarr);
    for i = 1, #inputarr, 1 do
        if (inputarr[i] ~= nil) and (inputarr[i] ~= "") then
            doublePrint(0, Q*(i-1), inputarr[i], white, scr);
        end;
    end;
end;

function strIsNumber(testers)
    if tonumber(testers) ~= nil then
       return 1;
    else
        return 0;
    end;
end;

function printChoiceMenu(inputChoiceTable, bgColor, highlightColor, inhighlighted)
    local rectHeight = math.floor(BS.h/#inputChoiceTable)
    for k = 1, #inputChoiceTable, 1 do
        if (k ~= inhighlighted) then
            doubleFillRect(0,BS.w,rectHeight*(k-1), rectHeight*k,bgColor,BOTTOM_SCREEN)
        else
            doubleFillRect(0,BS.w,rectHeight*(inhighlighted-1), rectHeight*inhighlighted,highlightColor,BOTTOM_SCREEN)
        end;
    end
    printTextBoxArray(inputChoiceTable, BOTTOM_SCREEN);
end;

function choice(choiceLine)
    local temp  = choiceLine:gsub("choice ","")
    local choiceTable = {};
    local z = 1;
    for word in string.gmatch(temp, '([^|]+)') do
        choiceTable[z] = word
        z = z + 1;
    end


     highlighted = 1;
    printChoiceMenu(choiceTable,black,red,highlighted)

    finished = 0
    while (finished == 0) do
        pad = Controls.read();
        if (Controls.check(pad,KEY_X)) and not (Controls.check(oldpad,KEY_X)) then
            finished = 1;
        elseif (Controls.check(pad,KEY_DDOWN   )) and not (Controls.check(oldpad,KEY_DDOWN   )) then
            if(highlighted ~= #choiceTable) then
                highlighted = highlighted + 1;
            else
                highlighted = 1
            end;
            printChoiceMenu(choiceTable,black,red,highlighted)

        elseif (Controls.check(pad,KEY_DUP    )) and not (Controls.check(oldpad,KEY_DUP    )) then
            if(highlighted ~= 1) then
                highlighted = highlighted - 1;
            else
                highlighted = #choiceTable
            end;
            printChoiceMenu(choiceTable,black,red,highlighted)
        end;
        oldpad = pad
    end

    return tostring(highlighted);
end;

function clearArray (inputarr)      --clears the linearray
    for i = 1, #inputarr, 1 do
        inputarr[i] = "";
    end;
end;

function textWrap(str, limit, indent, indent1)  --takes a string and a specified with and makes a new string with newlines of a specified width limite when the width of a single line is larger than the limit
  indent = indent or ""
  indent1 = indent1 or indent
  limit = limit or 72
  local here = 1-#indent1
  return indent1..str:gsub("(%s+)()(%S+)()",
                          function(sp, st, word, fi)
                            if fi-here > limit then
                              here = st - #indent
                              return "\n"..indent..word
                            end
                          end)
end

function delay(num)
    for i = 1, num, 1 do
        Screen.waitVblankStart();
    end
end;


function doubleDraw(x, y, filename, scr, renderType)
    if (renderType == CPU) then
        local tempimage = Screen.loadImage(filename);
        Screen.flip();
        Screen.drawImage(x,y,tempimage,scr);
        Screen.refresh();
        Screen.drawImage(x,y,tempimage,scr);
        Screen.freeImage(tempimage)

    elseif (renderType == GPU) then
        Graphics.initBlend(TOP_SCREEN)
        local tempimage = Graphics.loadImage(filename)
        Screen.flip()
        Graphics.drawImage(x, y, tempimage)
        Screen.refresh()
        Graphics.drawImage(x, y, tempimage)
        Graphics.termBlend()
        Graphics.freeImage(tempimage)
    end;
end;

function doublePrint(x, y, text, color, scr)
     Screen.flip();
     Screen.debugPrint(x, y, text, color, scr)
     Screen.refresh();
     Screen.debugPrint(x, y, text, color, scr)
end;

function doubleClearScreen(scr)   --fill entire screen with a color
    Screen.flip();
    Screen.clear(scr)
    Screen.refresh();
    Screen.clear(scr)
end;

function doubleFillRect(x1,x2,y1,y2,color,scr)   --fill entire screen with a color
    Screen.flip();
    Screen.fillRect(x1, x2, y1, y2, color, scr)
    Screen.refresh();
    Screen.fillRect(x1, x2, y1, y2, color, scr)
end;

function writeFileWithVar(filename, var)
    local fileStream = io.open(filename,FCREATE)
    io.write(fileStream,0,var,#var)
    io.close(fileStream)
end;

function strIsNumber(testers)
    if tonumber(testers) ~= nil then
       return 1;
    else
        return 0;
    end;
end;

function handleCurrentLine ()  --takes in currentline of game script and acts on it.
    local pauseExecute = 0
    while (pauseExecute == 0) do    --handling a textline triggers pausing and kicks back to to the main loop in order to allow user to read
        local currentline = indexedscript[i];
        local wordlist = makeWordList(currentline);
        if (wordlist[1] == "bgload") then
            doubleClearScreen(TOP_SCREEN);
            doubleDraw (40, 0, (gamePath .. "/background/" .. wordlist[2]),TOP_SCREEN, globalRenderType);

         elseif (wordlist[1] == "setimg") then
            local x = 0; local y = 0;
            if(#wordlist == 4) then
                local x = wordlist[3]; local y = wordlist[4];
            end;
            doubleDraw (x, y, (gamePath .. "/foreground/" .. wordlist[2]),TOP_SCREEN, globalRenderType);

         elseif (wordlist[1] == "text") then
            if (#wordlist > 1) then
                doubleClearScreen(BOTTOM_SCREEN)
                if  (wordlist[2] == "~") then
                    clearArray(textBoxArray);
                    doubleClearScreen(BOTTOM_SCREEN);
                elseif (wordlist[2] == "!") then
                    clearArray(textBoxArray);
                    doubleClearScreen(BOTTOM_SCREEN);
                    pauseExecute = 1;
                elseif (  wordlist[2]:sub(1,1) == "@"    ) then
                    writeTextBoxArray(textBoxArray, currentline:gsub("text @",""));
                else
                    writeTextBoxArray(textBoxArray, currentline:gsub("text ",""));
                    pauseExecute = 1;
                end;
                printTextBoxArray(textBoxArray, BOTTOM_SCREEN);
            end

         elseif (wordlist[1] == "cleartext") then
            clearArray(textBoxArray);
            doubleClearScreen(BOTTOM_SCREEN);

        elseif (wordlist[1] == "delay") then
            if (skipDelay ~= 1) then
                delay (wordlist[2]);
            end;

        elseif (wordlist[1] == "goto") then
            lookfor = wordlist[2];
            for q = 1, #indexedscript, 1 do
                if (string.find(indexedscript[q], ("label " .. lookfor)    ) ) then
                    i = q;
                end;
            end

        elseif (wordlist[1] == "setvar") then
            local LHS   = wordlist[2];
            local OP    = wordlist[3];
            local RHS   = wordlist[4];

            if (variables[LHS] == nil) then --fix error attempt to perform arithetic on nil value.  Happens when "setvar var + (a number)" when var hasn't been previously stated
                variables[LHS] = tostring(0);
            end;

            if (OP == "=") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] = tostring(RHS);
                else
                    variables[LHS] = tostring(variables[RHS]);
                end;

            elseif (OP == "+") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] =  tostring(math.floor(variables[LHS] + RHS));
                else
                    variables[LHS] =  tostring(math.floor(variables[LHS] + variables[RHS]));
                end;

            elseif (OP == "-") then
                if ( strIsNumber(RHS) == 1 ) then
                    variables[LHS] =  tostring(math.floor(variables[LHS] - RHS));
                else
                    variables[LHS] =  tostring(math.floor(variables[LHS] - variables[RHS]));
                end;

            end;

        elseif (wordlist[1] == "gsetvar") then
            local LHS   = wordlist[2];
            local OP    = wordlist[3];
            local RHS   = wordlist[4];

            if (globalvariables[LHS] == nil) then --fix error attempt to perform arithetic on nil value.  Happens when "gsetvar var + (a number)" when var hasn't been previously stated
                globalvariables[LHS] = tostring(0);
            end;


            if (OP == "=") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] = tostring(RHS);
                else
                    globalvariables[LHS] = tostring(globalvariables[RHS]);
                end;

            elseif (OP == "+") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] =  tostring(math.floor(globalvariables[LHS] + RHS));
                else
                    globalvariables[LHS] =  tostring(math.floor(globalvariables[LHS] + globalvariables[RHS]));
                end;

            elseif (OP == "-") then
                if ( strIsNumber(RHS) == 1 ) then
                    globalvariables[LHS] =  tostring(math.floor(globalvariables[LHS] - RHS));
                else
                    globalvariables[LHS] =  tostring(math.floor(globalvariables[LHS] - globalvariables[RHS]));
                end;

            end;

        elseif (wordlist[1] == "if") then
            --[NEWLY ADDED TO PREVENT IF ENDING >= 1 error in saya main.scr where Ending has not been previously declared
            if (variables[wordlist[2]] == nil) then --fix error attempt to perform arithetic on nil value.  Happens when "setvar var + (a number)" when var hasn't been previously stated
                variables[wordlist[2]] = tostring(0);
            end;

            local LHS   = variables[wordlist[2]];
            local OP    = wordlist[3];
            local RHS   = wordlist[4];  --Correct, VNDS doesn't support variables on the right

            doublePrint(0, 0,  LHS, red, TOP_SCREEN)
            doublePrint(0, 20, OP,  red, TOP_SCREEN)
            doublePrint(0, 40, RHS, red, TOP_SCREEN)

            if (evaluateIf(LHS,OP,RHS) == false) then
                doublePrint(0, 60, "FALSE", red, TOP_SCREEN)
                local count = 1;
                while count > 0 do
                    i = i + 1;
                    local cLine = indexedscript[i];
                    local cList = makeWordList(cLine);
                    if (cList[1] == "if") then
                        count = count + 1;
                    elseif (cList[1] == "fi") then
                        count = count - 1;
                    end;
                end;
            else
                doublePrint(0, 60, "TRUE", red, TOP_SCREEN)
            end;


        elseif (wordlist[1] == "choice") then
            --doubleDraw(0,0,vndsSystemPath .. "/blank.png",TOP_SCREEN, globalRenderType);
            local a =  choice(currentline)
            variables.selected = a
            doublePrint(0, 40, a, blue, TOP_SCREEN)
            ;--I have no idea what I'm doing.

        elseif ((wordlist[1] == "music") or (wordlist[1] == "sound")) then
            if (soundEnabled == 1) then
                format = (wordlist[2]:sub(#wordlist[2]-3,#wordlist[2]))
                if (format == ".ogg") then

                elseif(format == ".wav") then

                elseif(format == "AIFF" or format == ".AIF" ) then

                elseif(format == ".mp3") then

                end
            end;

        elseif (wordlist[1] == "random") then
            r1,r2,r3 = System.getTime()
            math.randomseed(r1 + r2 + r3)
            variables[wordlist[2]] = tostring(math.random(tonumber(wordlist[3]),tonumber(wordlist[4])) );

        elseif (wordlist[1] == "endscript") then
            delay(10000);
            clearArray(textBoxArray);
            doubleClearScreen(BOTTOM_SCREEN);

            clearArray(indexedscript);
            indexedscript = {};
            currentScriptFile =  (gamePath .. "/script/" .. "main.scr")
            fileToTable( currentScriptFile,indexedscript );
            i = 1;

        elseif (wordlist[1] == "jump") then
            clearArray(textBoxArray);
            doubleClearScreen(BOTTOM_SCREEN);

            clearArray(indexedscript);
            indexedscript = {};
            currentScriptFile =  (gamePath .. "/script/" .. wordlist[2])
            fileToTable( currentScriptFile,indexedscript );
            i = 1;
            collectgarbage()
        end;

    collectgarbage()
    i = i + 1;
    end;
end;

function countEntriesInTable(inTable)
    local count = 0
    for key,value in pairs(inTable) do
        count = count +1;
    end
    return count
end;

function ezioAppend(instream, input)
    io.write(instream,io.size(instream),tostring(input),#tostring(input))
end;

function savestate(filename)
    System.createDirectory(vndsSavePath)
    local fileStream = io.open(vndsSavePath .. gameName  .. ".SAV",FCREATE)

    ezioAppend(fileStream,gameName  .. "\n");
    ezioAppend(fileStream,currentScriptFile  .. "\n");
    ezioAppend(fileStream,i  .. "\n")

    ezioAppend(fileStream,"VARIABLES"  .. "\n")
    ezioAppend(fileStream, countEntriesInTable(variables)  .. "\n")
    for key,value in pairs(variables) do
        ezioAppend(fileStream,key .. " = " .. value .. " " .. type(value) .. "\n")
    end

    ezioAppend(fileStream,"GLOBALVARIABLES"  .. "\n")
    ezioAppend(fileStream, countEntriesInTable(globalvariables)  .. "\n")
    for key,value in pairs(globalvariables) do
        ezioAppend(fileStream,key .. " = " .. value .. "\n")
    end

    System.takeScreenshot(vndsSavePath .. gameName .. ".bmp",false)
    io.close(fileStream)
end;

function doubleDrawScreencapToScreen(filename)
    cap = Screen.loadImage(filename)

    Screen.flip();
    Screen.drawPartialImage(0,0,40,TS.h,BS.w,BS.h, cap,BOTTOM_SCREEN)
    Screen.drawPartialImage(0,0,0,0,TS.w,TS.h, cap,TOP_SCREEN)
    Screen.refresh();
    Screen.drawPartialImage(0,0,40,TS.h,BS.w,BS.h, cap,BOTTOM_SCREEN)
    Screen.drawPartialImage(0,0,0,0,TS.w,TS.h, cap,TOP_SCREEN)

    Screen.freeImage(cap)
end;

function loadstate(filename)
    local tempTable = {};
    fileToTable(vndsSavePath .. gameName .. ".SAV",tempTable);
    gameName = tempTable[1];
    currentScriptFile = tempTable[2];
    fileToTable(currentScriptFile,indexedscript)
    i = tonumber(tempTable[3]);

    local totalVariables  = tonumber(tempTable[5])
    local totalGVariables = tonumber(tempTable[5 + totalVariables + 2])

    for k = 1, totalVariables, 1 do
        list = makeWordList(tempTable[5+k])
        variables[list[1]] = tostring(list[3])
    end

    for k = 1, totalGVariables, 1 do
        list = makeWordList(tempTable[5 + totalVariables + 2 + k])
        variables[list[1]] = tostring(list[3])
    end

    clearArray(textBoxArray);
    doubleClearScreen(BOTTOM_SCREEN);

    doubleDrawScreencapToScreen(vndsSavePath .. gameName .. ".bmp")
end;

function exZip()
    local toExtractTable = {"foreground", "foreground", "script", "sound"}
    for k = 1, #toExtractTable, 1 do
        if (System.doesFileExist(gamePath .. "/" .. toExtractTable[k] .. ".zip")) then
            System.extractZIP(gamePath ..    "/" .. toExtractTable[k] .. ".zip", gamePath)
            System.deleteFile(gamePath ..    "/" .. toExtractTable[k] .. ".zip")
        end;
    end

end


Graphics.init()
Screen.refresh();
doubleDraw(0,0,vndsSystemPath .. "Loading.png",TOP_SCREEN, globalRenderType);
indexedscript = {};
currentScriptFile = gamePath .. "/script/main.txt"
fileToTable(currentScriptFile,indexedscript);

if (soundEnabled == 1) then
    soundEffect = Sound.openOgg("/blood2.ogg", false)
    Sound.init()
    Sound.play(soundEffect,NO_LOOP,0x08,0x09)
end;


doubleDraw(0,0,vndsSystemPath .. "DoneLoading.png",TOP_SCREEN, globalRenderType);

variables       = {};
variables.selected = 0
globalvariables = {};

i = 1;
while true do
    Screen.waitVblankStart();
	pad = Controls.read();

	if (Controls.check(pad,KEY_A)) and not (Controls.check(oldpad,KEY_A)) then
        if (i < #indexedscript) then  --prevent crashes by not trying to read further than table's length
            handleCurrentLine ();
        end
	elseif (Controls.check(pad,KEY_X)) and not (Controls.check(oldpad,KEY_X)) then  --debug keys
        --doubleDraw(0,0,gamePath .. "/foreground/fumi01.png",TOP_SCREEN, globalRenderType);
	elseif (Controls.check(pad,KEY_B)) then
        handleCurrentLine ()
	elseif (Controls.check(pad,KEY_Y)) and not (Controls.check(oldpad,KEY_Y)) then
        doubleFillRect(0, 280, 0, 14, black, TOP_SCREEN)
        doublePrint(0, 0, "KILOBYTES_IN_USE: " .. (math.floor(collectgarbage("count")*1024)), white, TOP_SCREEN)
	elseif (Controls.check(pad,KEY_START )) and not (Controls.check(oldpad,KEY_START )) then
        System.exit()
	elseif (Controls.check(pad,KEY_L )) and not (Controls.check(oldpad,KEY_L )) then
        loadstate("Saya01.sav");
    elseif (Controls.check(pad,KEY_R)) and not (Controls.check(oldpad,KEY_R )) then
        savestate("Saya01.sav");
    elseif (Controls.check(pad,KEY_SELECT )) and not (Controls.check(oldpad,KEY_SELECT  )) then
        if (soundEnabled == 1) then
            Sound.play(soundEffect,NO_LOOP,0x08,0x09)
        end
	end;

	oldpad = pad
	collectgarbage()
end;
